PlantSpawner = Class(function(self, inst)
    self.inst = inst
    self.has_spawned = false
    self.only_spawn_offscreen = true     
    self.inst:ListenForEvent("daytime", CheckUndergound, TheWorld)
    self.inst:ListenForEvent("seasontick", OnSeasonChange)    
end)
--local caved = GetWorld().prefab == "cave"
--local ruined = GetWorld().prefab == "ruin"
local caved = TheWorld == "cave"
local ruined = TheWorld == "ruin"
local spawnamount
local spawnplant   
local prefablist = 
    {        
        "berrybush",
        "carrot_planted",
        "wasphive",
        "deciduoustree",
        "evergreen",
        "grass",
        "marsh_bush",
        "green_mushroom",
        "red_mushroom",
        "blue_mushroom",
        "sapling",
        "beehive",
        "houndmound",
        --"lureplant",        
        "mermhouse",
        "molehill",        
        "pighouse",
        "rabbithole",        
        --"rock_ice",
        "tallbirdnest",
        "catcoonden",
        "reeds",
        "tentacle",
        "rabbithouse",

    }    
    local caveprefablist = 
    {        
        "berrybush",        
        "evergreen",
        "grass",
        "marsh_bush",
        "green_mushroom",
        "red_mushroom",
        "blue_mushroom",
        "sapling",        
        "reeds",
        "tentacle",
        "cave_fern",
        "slurtlehole",
        "flower_cave",
        "mushtree_tall",
        "mushtree_medium",
        "mushtree_small",
        "spiderhole",
        "lichen",
        "fissure",
        "fissure_lower",
        "rabbithouse",
        "tentacle_pillar",
        "tentacle_garden",

    }    
    local ruinprefablist = 
    {      
        
        "green_mushroom",
        "red_mushroom",
        "blue_mushroom",        
        "cave_fern",       
        "flower_cave",                
        "lichen",
        "fissure",
        "fissure_lower",
        "cave_banana_tree",
    }    

function OnSeasonChange(inst, data)
    inst.components.plantspawner:OnSeasonChange(inst, data)
end

function CheckUndergound(inst, data)
    --print("CheckUndergound function entered")
    if caved or ruined then        
        if ruined then print("You are in a ruin")
        elseif caved then print("You are in a cave")        
        end
        --if math.random(1, 10) == 7 then
            inst.components.plantspawner:OnSeasonChange(inst, data)
        --end
    else print("You are not in a cave")
    end
    local pinecones = {}    
    local birchnuts = {} 
    for guid, ent in pairs(Ents) do            
        if ent.entity:IsValid() and ent.prefab == "pinecone" and (not ent.only_spawn_offscreen or ent:IsAsleep()) then
            table.insert(pinecones, ent)
        elseif ent.entity:IsValid() and ent.prefab == "acorn" and (not ent.only_spawn_offscreen or ent:IsAsleep()) then
            table.insert(birchnuts, ent)
        end
    end
    if next(pinecones) ~= nil or next(birchnuts) ~= nil then
        if next(pinecones) ~= nil then

            for k,v in pairs(pinecones) do
                if v.components.inventoryitem and not (v.components.inventoryitem:IsHeld()) and not v.components.periodicspawner then 
                    v:AddComponent("periodicspawner")   
                    if math.random() < .2 then
                        v.components.periodicspawner:SetPrefab("evergreen_sparse_short")
                    else v.components.periodicspawner:SetPrefab("evergreen_short")
                    end
                    v.components.periodicspawner:SetRandomTimes(TUNING.TOTAL_DAY_TIME+120, 100)
                    v.components.periodicspawner:SetDensityInRange(4, 1)
                    v.components.periodicspawner:SetMinimumSpacing(4)
                    v.components.periodicspawner:SetOnSpawnFn(function(v) v:Remove() end)
                    v.components.periodicspawner:Start()
                elseif v.components.inventoryitem and v.components.inventoryitem:IsHeld() then
                    v:RemoveComponent("periodicspawner")
                end
            end
        end
        if next(birchnuts) ~= nil then

            for k,v in pairs(birchnuts) do
                if v.components.inventoryitem and not (v.components.inventoryitem:IsHeld()) and not v.components.periodicspawner then 
                    v:AddComponent("periodicspawner")                       
                    v.components.periodicspawner:SetPrefab("deciduoustree")                                        
                    v.components.periodicspawner:SetRandomTimes(TUNING.TOTAL_DAY_TIME+120, 100)
                    v.components.periodicspawner:SetDensityInRange(4, 1)
                    v.components.periodicspawner:SetMinimumSpacing(4)
                    v.components.periodicspawner:SetOnSpawnFn(function(v) v:Remove() end)
                    v.components.periodicspawner:Start()
                elseif v.components.inventoryitem and v.components.inventoryitem:IsHeld() then
                    v:RemoveComponent("periodicspawner")
                end
            end
        end
    else return
    end

end

function PlantSpawner:SpawnPlant()  
    if caved or ruined then spawnamount = 1
    else  spawnamount = math.random(1, 3)        
    end
    --print("spawnamount = "..spawnamount)
    for i=1, spawnamount do
        if not self.has_spawned then
            local loc = self:FindSpawnLocation()

            if loc then   
                --print("Spawning Plant")             
                local plant = SpawnPrefab(spawnplant.prefab)
                if plant.components.growable then
                    plant.components.growable:SetStage(1)
                end
                if math.random() < .3 then                    
                    local locnew = Vector3(loc.x + math.random(3, 10), loc.y, loc.z - math.random(3, 10))
                    local tiletype = TheWorld.Map:GetTileAtPoint(locnew:Get())
                    local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                    if ground_OK then                        
                        plant.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                    else
                        local locnew = Vector3(loc.x + math.random(3, 10), loc.y, loc.z - math.random(3, 10))
                        local tiletype = TheWorld.Map:GetTileAtPoint(locnew:Get())
                        local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                        if ground_OK then                        
                            plant.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                        else plant:Remove()
                            --print("Plant Deleted")
                        end
                    end
                elseif math.random() > .7 then
                    local locnew = Vector3(loc.x - math.random(3, 10), loc.y, loc.z + math.random(3, 10))
                    local tiletype = TheWorld.Map:GetTileAtPoint(locnew:Get())
                    local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                    if ground_OK then
                        plant.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                    else
                        local locnew = Vector3(loc.x - math.random(3, 10), loc.y, loc.z + math.random(3, 10))
                        local tiletype = TheWorld.Map:GetTileAtPoint(locnew:Get())
                        local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                        if ground_OK then
                            plant.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                        else plant:Remove()
                            --print("Plant Deleted")
                        end
                    end
                else
                    local locnew = Vector3(loc.x - math.random(3, 10), loc.y, loc.z - math.random(3, 10))
                    local tiletype = TheWorld.Map:GetTileAtPoint(locnew:Get())
                    local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                    if ground_OK then
                        plant.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                    else
                        local locnew = Vector3(loc.x - math.random(3, 10), loc.y, loc.z - math.random(3, 10))
                        local tiletype = TheWorld.Map:GetTileAtPoint(locnew:Get())
                        local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                        if ground_OK then
                            plant.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                        else plant:Remove()
                            --print("Plant Deleted")
                        end
                    end
                end                
            end
            --[[if index == #prefablist then index = 1
                else index = index + 1
            end]]
        end
    end
    if not caved or ruined then
        self.has_spawned = true
    end
end

function PlantSpawner:FindSpawnLocation() 
--print("Finding plant to spawn from......")   
    local allvalidplants = {}    
    for guid, ent in pairs(Ents) do    
        if ruined then   
            if ent.entity:IsValid() and ent.prefab == ruinprefablist[math.random(1, #ruinprefablist)] and (not self.only_spawn_offscreen or ent:IsAsleep()) then
                table.insert(allvalidplants, ent)            
            end
        elseif caved then
            if ent.entity:IsValid() and ent.prefab == caveprefablist[math.random(1, #caveprefablist)] and (not self.only_spawn_offscreen or ent:IsAsleep()) then
                table.insert(allvalidplants, ent)            
            end
        else
            if ent.entity:IsValid() and ent.prefab == prefablist[math.random(1, #prefablist)] and (not self.only_spawn_offscreen or ent:IsAsleep()) then
                table.insert(allvalidplants, ent)            
            end
        end        
    end    
    --print("Found "..(# allvalidplants).." valid plant entities to spawn from")
    ----print(index)
    if next(allvalidplants) == nil then
        return
    else
        spawnplant = GetRandomItem(allvalidplants)
        --print("Plant to spawn is "..spawnplant.prefab)
        return Vector3(spawnplant.Transform:GetWorldPosition())
    end
end

function PlantSpawner:OnSeasonChange(inst, data)
    --print("Seasonchange entered")
    local season = data.season
    --if season == SEASONS.WINTER or (SEASONS.SPRING ~= nil and season == SEASONS.SUMMER) then
        self.has_spawned = false   
        ----print("has_spawned is false due to season")
    --elseif (SEASONS.SPRING ~= nil and season == SEASONS.SPRING) or (SEASONS.SPRING == nil and season == SEASONS.SUMMER)
        --or (SEASONS.AUTUMN ~= nil and season == SEASONS.AUTUMN) or (SEASONS.AUTUMN == nil and season == SEASONS.SUMMER) then
        ----print("should enter spawnplant")
        self:SpawnPlant()
    if ruined or caved then
        self.has_spawned = false   
        self:SpawnPlant()
    end
    return season
end

function PlantSpawner:OnSave()
    if self.has_spawned then
        return{has_spawned = self.has_spawned}
    end
end

function PlantSpawner:OnLoad(data)
    if data then
        self.has_spawned = data.has_spawned
    end
    self:SpawnPlant()
end

return PlantSpawner